/*
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
*/


#include <stdlib.h>
#include <string.h>

#include "SDL.h"
#include "SDL_mixer.h"


#define	SCREEN_W	320
#define	SCREEN_H	240

#define UPKEY 1
#define DOWNKEY 2
#define LEFTKEY 3
#define RIGHTKEY 4
#define AKEY 5
#define BKEY 6
#define LKEY 7
#define RKEY 8
#define SEKEY 9
#define STKEY 10

char fets[67];

void fet(int f, int movs)
{
if (movs>255) movs=255;
if ((fets[f]>movs)  || (fets[f]==0))
fets[f]=movs;
}



char isfet(int f)
{
return fets[f];
}


void iniciarFets(void)
{ int i;
for (i=0;i<67;i++)
		fets[i]=0;
}

void guardarFets(void)
{  int i, j;
FILE *fetsfile = stdin;

	if ((fetsfile = fopen ("./gpmm/atomigfx/fet.dat", "w+")) == NULL) 	printf("error");

	for (i=0;i<67;i++)
	 fputc (fets[i], fetsfile);


	fclose (fetsfile);
}

void carragarFets(void)
{  int i, j;
FILE *fetsfile = stdin;

	if ((fetsfile = fopen ("./gpmm/atomigfx/fet.dat", "rb")) == NULL) 	
	{printf("error"); iniciarFets();}
	else
	{
	for ( i=0;i<67;i++)
	fets[i] = fgetc (fetsfile);


	fclose (fetsfile);
	}
}

void SDL_print(char *c, int x, int y, SDL_Surface *fnt, SDL_Surface *screen)
{ int n;
n=0;

while(c[n]!='\0')
	if (c[n]>96 && c[n]<(96+27))
	{
		SDL_Rect orig;
		orig.x = 6*(c[n]-97);
		orig.y = 0;
		orig.h=24;
		orig.w=6;
		
		SDL_Rect dest;
		dest.x = x+6*n;
		dest.y = y;

 SDL_SetColorKey(fnt, SDL_SRCCOLORKEY,
		 SDL_MapRGB(fnt->format, 255,255,255));		
		SDL_BlitSurface(fnt, &orig, screen, &dest);
		n++;
	} else 
	if (c[n]>=65 && c[n]<(65+27))
	{
		SDL_Rect orig;
		orig.x = 6*(c[n]-65+26);
		orig.y = 0;
		orig.h=24;
		orig.w=6;
		
		SDL_Rect dest;
		dest.x = x+6*n;
		dest.y = y;

 SDL_SetColorKey(fnt, SDL_SRCCOLORKEY,
		 SDL_MapRGB(fnt->format, 255,255,255));		
		SDL_BlitSurface(fnt, &orig, screen, &dest);
		n++;
	}
	else if(c[n]>=48 && c[n]<=(48+10))
	{
		SDL_Rect orig;
		orig.x = 6*(c[n]-49+26+26);
		orig.y = 0;
		orig.h=24;
		orig.w=6;
		
		SDL_Rect dest;
		dest.x = x+6*n;
		dest.y = y;

 SDL_SetColorKey(fnt, SDL_SRCCOLORKEY,
		 SDL_MapRGB(fnt->format, 255,255,255));		
		SDL_BlitSurface(fnt, &orig, screen, &dest);
		n++;
			
	
	}
	else n++;

}


int getThisKey(SDL_Event	event)
{
	

	if (event.type == SDL_KEYDOWN)
	{
	switch (event.key.keysym.sym)
	{
	case SDLK_SPACE: return STKEY;
	case SDLK_UP: return UPKEY;
	case SDLK_DOWN: return DOWNKEY;
	case SDLK_RIGHT: return RIGHTKEY;
	case SDLK_LEFT: return LEFTKEY;
	case SDLK_RETURN: return SEKEY;
	case SDLK_TAB: return LKEY;
	case SDLK_BACKSPACE: return RKEY;
	case SDLK_LCTRL: return AKEY;
	case SDLK_LALT: return BKEY;
	
	}
	}
	return 0;
}



void intro(SDL_Surface *screen,  SDL_Surface *atoms3, SDL_Surface *fons)
{
	int i,j;
	SDL_Event	event;

int particulax[50];
int particulay[50];
int particulavx[50];
int particulavy[50];
int particulac[50];

for (i=0;i<50;i++)
{
	particulax[i]=170;
	particulay[i]=4;
	particulac[i]=-1;

}
  
  
 srand(200);
 while(SDL_PollEvent(&event) >= 0)
 {
   for (i=0;i<50;i++)
	{
		if (particulac[i]==-1)
		{
		particulax[i]=170;	particulay[i]=50;
		particulac[i]=-1;	particulavx[i]=(rand()%10)-6;	
		if (particulavx[i]==0) particulavx[i]++;
		particulavy[i]=-(rand()%15);	particulac[i]=(rand()%3);			
		break; // Afegim de un en un
		}
	}
	
	if (getThisKey(event)!=0)	break;	// No te objectiu

	if (event.type == SDL_KEYDOWN)	break;	// No te objectiu
	draw_fons(screen, fons, 0, 0);

   for (i=0;i<50;i++)
	{
		if (particulay[i]>165 && particulax[i]>40 && particulax[i]<300 ) particulavy[i]=-particulavy[i];
		particulavy[i]++;	particulax[i]+=particulavx[i]; 	particulay[i]+=particulavy[i];
	DrawI( atoms3,  screen, 0+particulac[i]*30, 0, 30, 30, particulax[i],particulay[i]);
	}

	SDL_Flip(screen);
	SDL_Delay(2);
	}
  SDL_Delay(1000);
}


int dibuixarMenu(SDL_Surface *screen, SDL_Surface *fons, SDL_Surface *atoms3, SDL_Surface *font)
{
	SDL_Event	event;
int opcio=0;
int saltar=0;

while(SDL_PollEvent(&event) >= 0)
{ 

if (event.type == SDL_KEYDOWN && saltar !=0)
	{
	 if (event.key.type==SDL_KEYDOWN)
	  {
	 	saltar=0;
		if (getThisKey(event)==STKEY) break;	
		if (getThisKey(event)==UPKEY) opcio--;
		if (getThisKey(event)==DOWNKEY) opcio++;
	  }
	}else {saltar=1;}
		
		
	if (opcio>5) opcio=5;
	if (opcio==-1) opcio=0;
	
		draw_fons(screen, fons, 0, 0);
	SDL_print("New Game or Continue",60,60,font,screen);
	SDL_print("Select Level",60,80,font,screen);
	SDL_print("Options",60,100,font,screen);
	SDL_print("Save Game",60,120,font,screen);
	SDL_print("Credits",60,140,font,screen);
	SDL_print("Quit (and save)",60,160,font,screen);
	DrawI( atoms3,  screen, 0, 0, 30, 30, 30,60+opcio*20);
	SDL_Delay(100);
	SDL_Flip(screen);
		
	}

	SDL_Delay(1000);

return opcio;

}

int dibuixarMenu2(SDL_Surface *screen, SDL_Surface *fons, SDL_Surface *atoms3, SDL_Surface *font)
{
	SDL_Event	event;
	char str[100];
static int opcio=0;
static int opcioMusica=0;
int saltar=0;
while(SDL_PollEvent(&event) >= 0)
{ 



		if ((getThisKey(event)!=0)&& saltar !=0)
		{if ((getThisKey(event)!=0))
		{
			saltar=0;
			if((getThisKey(event)==STKEY)) return -1;
			
			if(getThisKey(event)==UPKEY) opcio--;
			if(getThisKey(event)==DOWNKEY) opcio++;
			if (opcio==0)
			{
			if(getThisKey(event)==LEFTKEY)
			   {
				opcioMusica--; if (opcioMusica<0) opcioMusica=0; return opcioMusica;
			   }
			if(getThisKey(event)==RIGHTKEY) 
            {
			   opcioMusica++; return opcioMusica;
            }
            			
			}
		} }else {saltar=1;}
		

	if (opcio>3) opcio=3;
	if (opcio==-1) opcio=0;
	
		draw_fons(screen, fons, 0, 0);
		
		if(opcioMusica==0)
            sprintf(str, "Music    all songs");
        else
			sprintf(str, "Music    song %d",opcioMusica);
			
	SDL_print(str,60,60,font,screen);
	SDL_print("Return to menu",60,80,font,screen);
	DrawI( atoms3,  screen, 0, 0, 30, 30, 30,60+opcio*20);


	SDL_Delay(100);
		SDL_Flip(screen);
		
}


}





int dibuixarMenu3(SDL_Surface *screen, SDL_Surface *fons, SDL_Surface *atoms3, SDL_Surface *font)
{
int saltar=0; int i;
int opcio=0;  char str[100];
	SDL_Event	event;

	while(SDL_PollEvent(&event) >= 0)
	{ 
	
		if (getThisKey(event)!=0 && saltar !=0)
		{if (getThisKey(event)!=0)
		{ saltar=0;
			if(getThisKey(event)==STKEY)
			break;	
			if(getThisKey(event)==LEFTKEY) opcio-=20;
			if(getThisKey(event)==RIGHTKEY) opcio+=20;			
			if(getThisKey(event)==UPKEY) opcio--;
			if(getThisKey(event)==DOWNKEY) opcio++;
		}}else {saltar=1;}
		
		
	if (opcio>66) opcio=66; if (opcio<-1) opcio=0;
		draw_fons(screen, fons, 0, 0);


	for(i=0; i<20;i++)
		{	
			sprintf(str,"Level %d %d",i+1,isfet(i));
			SDL_print(str,15+0,5+10*i,font,screen);
		}	
		
	for(i=0; i<20;i++)
		{	
			sprintf(str,"Level %d %d",20+i+1,isfet(20+i));
			SDL_print(str,35+60,5+10*i,font,screen);
		}	


	for(i=0; i<20;i++)
		{	
			sprintf(str,"Level %d %d",40+i+1,isfet(40+i));
			SDL_print(str,55+120,5+10*i,font,screen);
		}	


	for(i=0; i<=6;i++)
		{	
			sprintf(str,"Level %d %d",60+i+1,isfet(60+i));
			SDL_print(str,70+180,5+10*i,font,screen);
		}	


	if (isfet(opcio)==0)	
		DrawI( atoms3,  screen, 0, 0, 15, 15, 80*(opcio/20), 10+(((opcio)%20)*10));
	else
		DrawI( atoms3,  screen, 15, 0, 15, 15, 80*(opcio/20), 10+(((opcio)%20)*10));
	
		SDL_Flip(screen);
		SDL_Delay(200);
	}
	return opcio;
	
}

/*
char molec[67][60] = {"Wasser", "Methan", "Methanol", "Aethylen", "Propylen (Propen)", "Aethanol", "Iso-Propanol", 
"Aethanal","Azeton","Ameisensaeure","Essigsaeure","Trans-Butylen","Cis-butylen","Dimethylaether","Butanol",
"tertiaeres Isobutanol","Propantriol (Glycerin)","Poly-Tetra-Flouraethan","Oxylsaeure","Formaldehyd","Kristall 1","Ester",
"Ammoniak","Methylpentan","Propanal","Aethin","Bernsteinsaeureanhydrid","Pyran","Zyklopentan","Nitroglyzerin","Ethan","Kristall 2",
"Glykol","Alanin","Dizyandiamid","Blausaeure","Anthrazen","Thiazol","Saccharin","Styrol","Melamin","Cyclobutan","Nikotin",
"Acetylsalicylsaeure","Dinitrobenzolsaeure","Propin","Malonsaeure","Dimethylpropan","Aethylbenzol","Asparagin","Cyclooctatetraen",
"Vanillin","Kristall 3","Harnsaeure","Thymin","Anilin","Chloroform","Kohlensaeure","Kristall 4","Akrylnitril","Furan","Milchsaeure",
"Maleinsaeure","Weinsaeure","Kristall 5","Ameisensaeure-Aethylester","Para-Chinon"};
*/
char molec[67][60] = {"Water", "methane", "methanol", "ethylen", "propylene (propen)", "ethanol", "isopropanol","Aethanal", "acetone", "formic acid", "acetic", "acid Trans Butylen", "Cis-butylen", "Dimethylaether", "butanol","tertiary Isobutanol", "Propantriol (Glycerin)", "Poly Tetra Flouraethan", "Oxylsaeure", "formaldehyde", "crystal 1",  "ester", "ammonia", "methyl", "pentane", "Propanal", "Aethin", "succinic acid anhydride", "Pyran", "Zyklopentan", "nitroglycerin", "Ethan", "crystal 2","glycol", "alanine", "Dizyandiamid", "prussic acid",  "anthracene", "Thiazol", "Saccharin", "styrene", "Melamin", "cyclobutane", "nicotine","acetylsalicylic", "acid Dinitrobenzolsaeure" "pro pin", "malonic acid", "Dimethylpropan", "ethyl", "benzene", "asparagine", "Cyclooctatetraen","vanillin", "crystal 3", "urine acid", "thymine", "aniline", "chloroform", "carbonic acid", "crystal 4", "Akrylnitril", "Furan", "lactic acid","maleic acid", "tartaric acid", "crystal 5", "formic acid ethyl esters", "para-Chinon"};

